//------------------------------------------------------------------------
//  HTML FABRICATION Tool Report Format File (report body)
//  NOTE: Formats are driven off of the op SNCS associated with a tool.
//------------------------------------------------------------------------

extern string tm_notes;
extern float tl_dia, cradius, length, width, slope;

//	Tool specific procedures below
//	Each "tool" is a table nested in the larger report table

//	Add a row to tool report banner with gview screen cap
procedure tlrpt_image
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreportimg\" align=\"center\">");
	format("<center><img class=\"report\" src=\"%s\" height=\"600\" width=\"800\" /></center></td>\n", get_name(report_image_get(1, 800, 600)));
	format("\t\t\t</tr>\n");
}

//	Create the initial Tool Report table - this creates the table banner and establishes the table
procedure tool_header
{
	format("\t\t<table class=\"toolreport\">\n");

	//	report table banner row
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<th class=\"toolreport\"><H2>Tool Report</H2></th>\n");
	format("\t\t\t</tr>\n");

	//	add bitmap of gview if requested
	call_if_report_image(tlrpt_image);
}

//	Close out the Tool Report table - add footer row if needed
procedure tool_footer
{
	format("\t\t</table>\n");
}

//	Wrapper procedures used by tool report tables
//	These exist only to make it easier to create the standard nested table rows, cells, and tables

//	create a Row in the main Tool Report table, for the nested Tool table
procedure create_tlcell
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreport\">\n");

	//	create inner table for record data
	format("\t\t\t\t\t<table class=\"tlrpt2\">\n");
}

procedure close_tlcell
{
	format("\t\t\t\t\t</table>\n");
	format("\t\t\t\t</td>\n");
	format("\t\t\t</tr>\n");
}

procedure open_row
{
	format("\t\t\t\t\t\t<tr class=\"tlrpt2\">\n");
}

procedure close_row
{
	format("\t\t\t\t\t\t</tr>\n");
}

procedure spacer_cell_2col
{
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}

procedure format_tool_image
{
	format("\t\t\t\t\t\t\t<td class=\"tlrptimg\" rowspan=3>\n");
	format("\t\t\t\t\t\t\t\t<img class=\"report\" src=\"%s\" height=\"150\" width=\"150\" />\n", get_name(tool_image_get(150,150,1)));
	format("\t\t\t\t\t\t\t</td>\n");
}

procedure format_tl_num
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-4d</td>\n", tl_num);
}

procedure format_tl_desc
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Description:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=5>%s</td>\n", tl_desc);
}
procedure format_tl_desc_0col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Description:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%s</td>\n", tl_desc);
}
procedure format_tl_desc_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Description:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=3>%s</td>\n", tl_desc);
}
procedure format_tm_notes
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Notes:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=5>%s</td>\n", tm_notes);
}
procedure format_tm_notes_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Notes:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=3>%s</td>\n", tm_notes);
}
procedure format_tm_notes_7col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Notes:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=7>%s</td>\n", tm_notes);
}
procedure format_tl_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", tl_dia);
}

procedure format_width
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Width:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", width);
}

procedure format_web_width
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Web Width:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", width);
}

procedure format_length
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Length:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", length);
}

procedure format_cradius
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Corner Radius:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-5.2f</td>\n", cradius);
}

procedure format_web_radius
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Radius:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-5.2f</td>\n", cradius);
}

procedure format_slope
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Slope:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-8.4f</td>\n", slope);
}

procedure row_image_tnum_desc
{
	call(open_row);
	call (format_tool_image);
	call (format_tl_num);
	call (format_tl_desc);
	call(close_row);
}
procedure row_image_tnum_desc_nospan
{
	call(open_row);
	call (format_tool_image);
	call (format_tl_num);
	call (format_tl_desc_0col);
	call(close_row);
}
procedure row_image_tnum_desc_desc3
{
	call(open_row);
	call (format_tool_image);
	call (format_tl_num);
	call (format_tl_desc_3col);
	call(close_row);
}

procedure row_tnotes
{
	call(open_row);
	call(format_tm_notes);
	call(close_row);
}
procedure row_tnotes_3col
{
	call(open_row);
	call(format_tm_notes_3col);
	call(close_row);
}
procedure row_tnotes_7col
{
	call(open_row);
	call(format_tm_notes_7col);
	call(close_row);
}
procedure row_dia
{
	call(open_row);
	call(format_tl_dia);
	call(spacer_cell_2col);
	call(close_row);
}

procedure row_width
{
	call(open_row);
	call (format_width);
	call(spacer_cell_2col);
	call(close_row);
}


procedure row_length_width_crad
{
	call (open_row);
	call (format_length);
	call (format_width);
	call (format_cradius);
	call (close_row);
}

procedure row_length_wwid_wrad
{
	call (open_row);
	call (format_length);
	call (format_web_width);
	call (format_web_radius);
	call (close_row);
}

procedure row_length_width
{
	call (open_row);
	call (format_length);
	call (format_width);
	call (close_row);
}

procedure row_dia_width
{
	call (open_row);
	call (format_tl_dia);
	call (format_width);
	call (close_row);
}

procedure row_length_width_slope_crad
{
	call (open_row);
	call (format_length);
	call (format_width);
	call (format_slope);
	call (format_cradius);
	call (close_row);
}

//	Fail-safe format: default procedure in event of failure
procedure section_2430000
{
	call(create_tlcell);
	call (row_image_tnum_desc);
	call (row_length_width);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2430401  // round punch
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_dia);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430402  // square
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430403  // rectangle
{
	call(create_tlcell);
	call (row_image_tnum_desc_desc3);
	call (row_length_width_crad);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2430404  // obround
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_length_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430405  // diamond
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_length_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430407  // radius
{
	call(create_tlcell);
	call (row_image_tnum_desc_desc3);
	call (row_length_wwid_wrad);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2430408  // single D
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_dia_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430409  // double D
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_dia_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430410  // trapezoid
{
	call(create_tlcell);
	call (row_image_tnum_desc);
	call (row_length_width_slope_crad);
	call (row_tnotes_7col);
	call(close_tlcell);
}

procedure section_2430406  // other
{
	call(create_tlcell);
	call (row_image_tnum_desc_nospan);
	call (row_length_width);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430501 // laser
{
	call(create_tlcell);
	call (format_tl_num);
	call (format_tl_desc);
	call (row_tnotes_3col);
	call(close_tlcell);
}

procedure section_2430502 // burner
{
	call (section_2430501);
}
