//--------------------------------------------------------------------------
//  MILLING PRODUCTS HTML Job Report Format File (report body)
//  NOTE: This file is included by product specific step and tool reports.
//--------------------------------------------------------------------------

extern string created, creator;
extern string job_note, nc_date, nc_file;
extern string rev_date, prt_desc, matl_desc;
extern string nc_runtime, wc_desc;
extern integer rev, units, app_type;
//	extern string jof_file declared in mill_jobreport_htm.fmt - if don't get 12016 error

//	Create the initial Job Report table - this establishes the table
procedure job_header
{
	format("\t\t<table class=\"jobreport\">\n");

	//	report table banner row
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\" colspan=6><H2>Job Report</H2></th>\n");
	format("\t\t\t</tr>\n");
}

//	Close out the Job Report table - add footer row if needed
procedure job_footer
{
	format("\t\t</table>\n");
}

//	Convert App_type to string
procedure apptype
{
	format("%s", map(app_type, [1="Milling", 2="Turning", 3="Fabrication", 4="Wire EDM"]));
}

//	convert units to string
procedure unitconv
{
	format("%s", map(units, [0="Inch", 1="Metric"]));
}

//	Add a row to Job Report with bitmap, if user selects it
procedure jobrpt_image
{
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<td class=\"jobreportimg\" colspan=6 align=\"center\">");
	format("<center><img class=\"report\" src=\"%s\" height=\"600\" width=\"800\"/></center></td>\n", get_name(report_image_get(1, 800, 600)));
	format("\t\t\t</tr>\n");
}


procedure section_5010000
{
	//	PM5 path/filename
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\" width=\"15\%\">Process Model File:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", shpfile());
	format("\t\t\t</tr>\n");

	//	JOF path/filename
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\" width=\"200\">Job Operations File:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", jof_file);
	format("\t\t\t</tr>\n");

	//	created by
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Created By:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", creator);
	format("\t\t\t</tr>\n");

	//	date created, date revised, # revisions
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Date Created:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\">%s</td>\n", created);
	format("\t\t\t\t<th class=\"jobreport\" width=\"15\%\">Date Revised:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\">%s</td>\n", rev_date);
	format("\t\t\t\t<th class=\"jobreport\" width=\"15\%\">Revisions:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\">%d</td>\n", rev);
	format("\t\t\t</tr>\n");

	//	machine description
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Machine:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", wc_desc);
	format("\t\t\t</tr>\n");

	//	machine type, units
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Machine Type:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\">");
	call(apptype);
	format("</td>\n");
	format("\t\t\t\t<th class=\"jobreport\">Units:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=3>");
	call(unitconv);
	format("</td>\n");
	format("\t\t\t</tr>\n");

	//	cnc runtime, last cnc code date
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">CNC Runtime:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\">%s</td>\n", nc_runtime);
	format("\t\t\t\t<th class=\"jobreport\">CNC Code Date:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=3>%s</td>\n", nc_date);
	format("\t\t\t</tr>\n");

	//	cnc g-code output path/file
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">G-Code File:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", nc_file);
	format("\t\t\t</tr>\n");

	//	part description
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Part Description:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", prt_desc);
	format("\t\t\t</tr>\n");

	//	material description
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Material Description:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", matl_desc);
	format("\t\t\t</tr>\n");

	//	job notes
	format("\t\t\t<tr class=\"jobreport\">\n");
	format("\t\t\t\t<th class=\"jobreport\">Notes:</th>\n");
	format("\t\t\t\t<td class=\"jobreport\" colspan=5>%s</td>\n", job_note);
	format("\t\t\t</tr>\n");

	//	add bitmap, if user opted for one
	call_if_report_image(jobrpt_image);
}
