//------------------------------------------------------------------------
//  HTML MILLING Tool Report Format File (report body)
//  NOTE: Formats are driven off of the op SNCS associated with a tool.
//------------------------------------------------------------------------

extern string tm_notes;
extern float tl_len, tl_dia, cradius, tipangl, pitch, sideang, plt_dia, body_dia;

//	Tool specific procedures below
//	Each "tool" is a table nested in the larger report table

//	Add a row to tool report banner with gview screen cap
procedure tlrpt_image
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreportimg\" align=\"center\">");
	format("<center><img class=\"report\" src=\"%s\" height=\"600\" width=\"800\" /></center></td>\n", get_name(report_image_get(1, 800, 600)));
	format("\t\t\t</tr>\n");
}

//	Create the initial Tool Report table - this creates the table banner and establishes the table
procedure tool_header
{
	format("\t\t<table class=\"toolreport\">\n");

	//	report table banner row
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<th class=\"toolreport\"><H2>Tool Report</H2></th>\n");
	format("\t\t\t</tr>\n");

	//	add bitmap of gview if requested
	call_if_report_image(tlrpt_image);
}

//	Close out the Tool Report table - add footer row if needed
procedure tool_footer
{
	format("\t\t</table>\n");
}

//	Wrapper procedures used by tool report tables
//	These exist only to make it easier to create the standard nested table rows, cells, and tables

procedure create_tlcell
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreport\">\n");

	//	create inner table for record data
	format("\t\t\t\t\t<table class=\"tlrpt2\">\n");
}

procedure close_tlcell
{
	format("\t\t\t\t\t</table>\n");
	format("\t\t\t\t</td>\n");
	format("\t\t\t</tr>\n");
}

procedure open_row
{
	format("\t\t\t\t\t\t<tr class=\"tlrpt2\">\n");
}

procedure close_row
{
	format("\t\t\t\t\t\t</tr>\n");
}

procedure format_tool_image
{
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" rowspan=3>\n");
	format("\t\t\t\t\t\t\t\t<img class=\"report\" src=\"%s\" height=\"150\" width=\"150\" />\n", get_name(tool_image_get(150,150,1)));
	format("\t\t\t\t\t\t\t</td>\n");
}

procedure format_tool_image3
{
	format("\t\t\t\t\t\t\t<td rowspan=3>\n");
	format("\t\t\t\t\t\t\t\t<img class=\"report\" src=\"%s\" height=\"150\" width=\"150\" />\n", get_name(tool_image_get(150,150,1)));
	format("\t\t\t\t\t\t\t</td>\n");
}

procedure format_tl_num
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-4d</td>\n", tl_num);
}


procedure format_tl_desc
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Description:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=3>%s</td>\n", tl_desc);
}

procedure format_tm_notes
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Notes:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=7>%s</td>\n", tm_notes);
}

procedure format_tool_material
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Material:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">");
	call (tool_material);
	format("</td>\n");
}

procedure format_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", tl_dia);
}

procedure format_len
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Length:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", tl_len);
}

procedure format_sideang
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Side Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", sideang);
}
procedure format_sideang_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Side Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", sideang);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}

procedure format_body_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Body Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", body_dia);
}
procedure format_body_dia_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Body Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", body_dia);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}

procedure format_tipangl
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tip Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", tipangl);
}
procedure format_tipangl_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tip Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", tipangl);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}

procedure format_pitch
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pitch:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", pitch);
}
procedure format_pitch_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pitch:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", pitch);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}
procedure format_plt_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pilot Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", plt_dia);
}
procedure format_plt_dia_3col
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pilot Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", plt_dia);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2>&nbsp;</td>\n");
}

procedure format_cradius
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Corner Radius:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", cradius);
}

procedure row_tnotes
{
	call(open_row);
	call (format_tm_notes);
	call(close_row);
}

procedure subrow_dia_len
{
	call (format_dia);
	call (format_len);
}

procedure row_image_tnum_desc_material
{
	call(open_row);
	call (format_tool_image);
	call (format_tl_num);
	call (format_tl_desc);
	call (format_tool_material);
	call(close_row);
}
//	same as above, but uses rowspan of 3
procedure row_image_tnum_desc_material3
{
	call(open_row);
	call (format_tool_image3);
	call (format_tl_num);
	call (format_tl_desc);
	call (format_tool_material);
	call(close_row);
}

procedure row_dia_len_sideang
{
 	call(open_row);
	call (subrow_dia_len);
	call (format_sideang_3col);
 	call(close_row);
}

procedure row_dia_len_tipangl
{
	call(open_row);
	call (subrow_dia_len);
	call (format_tipangl_3col);
	call(close_row);
}
procedure row_dia_len_pitch
{
	call(open_row);
	call (subrow_dia_len);
	call (format_pitch_3col);
	call(close_row);
}

procedure row_dia_len_pdia
{
	call(open_row);
	call (subrow_dia_len);
	call (format_plt_dia_3col);
	call(close_row);
}
procedure row_dia_len_sideang_crad
{
	call(open_row);
	call (subrow_dia_len);
	call (format_sideang);
	call (format_cradius);
	call(close_row);
}

procedure row_dia_len_bdia_crad
{
	call(open_row);
	call (subrow_dia_len);
	call (format_body_dia);
	call (format_cradius);
	call(close_row);
}

procedure row_dia_len_bdia
{
	call(open_row);
	call (subrow_dia_len);
	call (format_body_dia_3col);
	call(close_row);
}

procedure row_dia_len
{
	call(open_row);
	call (subrow_dia_len);
	call(close_row);
}




//	Fail-safe format: default procedure in event of failure
procedure section_2410000
{
	call (create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len);
	call (row_tnotes);
	call (close_tlcell);
}


procedure section_2410101  // end mill
{
	call (create_tlcell);

	call (row_image_tnum_desc_material3);
	call (row_dia_len_sideang);
	call (row_tnotes);

	// close out the inner table and row
	call(close_tlcell);
}

procedure section_2410102 // ball mill
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_sideang_crad);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410103 // face mill
{
	call(section_2410102);
}

procedure section_2410104  // form mill
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_bdia_crad);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410105  // bull mill
{
	call(section_2410102);
}


// Hole tool formats

procedure section_2410201  // spot drill
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_tipangl);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410202  // twist drill
{
	call(section_2410201);
}

procedure section_2410203  // reamer
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410204  // bore
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410205 // tap
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_pitch);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410206  // counterbore
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_pdia);
	call (row_tnotes);
	call(close_tlcell);
}

procedure section_2410207  // countersink
{
	call(section_2410201);
}

procedure section_2410208  // form hole
{
	call(section_2410206);
}

procedure section_2410209  // center drill
{
	call(create_tlcell);
	call (row_image_tnum_desc_material3);
	call (row_dia_len_bdia);
	call (row_tnotes);
	call(close_tlcell);
}
