//------------------------------------------------------------------------
//  HTML TURNING Tool Report Format File (report body)
//  NOTE: Formats are driven off of the op SNCS associated with a tool.
//------------------------------------------------------------------------

extern string insrt_id, tm_notes;
extern float tl_len, tl_dia, cradius, tipangl, pitch, sideang, plt_dia, body_dia;
extern float width, length, insrtsiz, max_depth;

//	Tool specific procedures below
//	Each "tool" is a table nested in the larger report table

//	Add a row to tool report banner with gview screen cap
procedure tlrpt_image
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreportimg\" align=\"center\">");
	format("<center><img class=\"report\" src=\"%s\" height=\"600\" width=\"800\" /></center></td>\n", get_name(report_image_get(1, 800, 600)));
	format("\t\t\t</tr>\n");
}

//	Create the initial Tool Report table - this creates the table banner and establishes the table
procedure tool_header
{
	format("\t\t<table class=\"toolreport\">\n");

	//	report table banner row
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<th class=\"toolreport\"><H2>Tool Report</H2></th>\n");
	format("\t\t\t</tr>\n");

	//	add bitmap of gview if requested
	call_if_report_image(tlrpt_image);
}

//	Close out the Tool Report table - add footer row if needed
procedure tool_footer
{
	format("\t\t</table>\n");
}

procedure open_row
{
	format("\t\t\t\t\t\t<tr class=\"tlrpt2\">\n");
}

procedure close_row
{
	format("\t\t\t\t\t\t</tr>\n");
}

//	Wrapper procedures used by tool report tables
//	These exist only to make it easier to create the standard nested table rows, cells, and tables

procedure create_tlcell
{
	format("\t\t\t<tr class=\"toolreport\">\n");
	format("\t\t\t\t<td class=\"toolreport\">\n");

	//	create inner table for record data
	format("\t\t\t\t\t<table class=\"tlrpt2\">\n");
}

procedure close_tlcell
{
	format("\t\t\t\t\t</table>\n");
	format("\t\t\t\t</td>\n");
	format("\t\t\t</tr>\n");
}

procedure format_tool_image
{
	format("\t\t\t\t\t\t\t<td rowspan=4>\n");
	format("\t\t\t\t\t\t\t\t<img class=\"report\" src=\"%s\" height=\"150\" width=\"150\" />\n", get_name(tool_image_get(150,150,1)));
	format("\t\t\t\t\t\t\t</td>\n");
}
procedure format_tool_image_3row
{
	format("\t\t\t\t\t\t\t<td rowspan=3>\n");
	format("\t\t\t\t\t\t\t\t<img class=\"report\" src=\"%s\" height=\"150\" width=\"150\" />\n", get_name(tool_image_get(150,150,1)));
	format("\t\t\t\t\t\t\t</td>\n");
}

procedure format_tl_num
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\" width=6em>Tool:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"10%%\">%-4d</td>\n", tl_num);
}

procedure format_tl_desc_cs3
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Description:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=3>%s</td>\n", tl_desc);
}

procedure format_tl_desc_cs5
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Descriptionc:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=5>%s</td>\n", tl_desc);
}

procedure format_tool_material
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Material:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">");
	call (tool_material);
	format("</td>\n");
}

procedure format_tm_notes
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tool Notes:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=7>%s</td>\n", tm_notes);
}

procedure format_turret
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Turret:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-4d</td>\n", turret);
}

procedure format_cradius
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Corner Radius:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-8.4f</td>\n", cradius);
}

procedure format_insrt_id
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Insert ID:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%s</td>\n", insrt_id);
}

procedure format_insrtsiz
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Size:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", insrtsiz);
}

procedure format_max_depth
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Max Depth:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", max_depth);
}

procedure format_width
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Width:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=5>%-8.4f</td>\n", width);
}

procedure format_length
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Length:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-8.4f</td>\n", length);
}

procedure format_tl_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Diameter:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-8.4f</td>\n", tl_dia);
}

procedure format_tl_len
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Length:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\">%-8.4f</td>\n", tl_len);
}

procedure format_sideang
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Side Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", sideang);
}

procedure format_body_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Body Dia:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", body_dia);
}

procedure format_tipangl
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Tip Angle:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-5.2f</td>\n", tipangl);
}

procedure format_pitch
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pitch:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-5.2f</td>\n", pitch);
}

procedure format_plt_dia
{
	format("\t\t\t\t\t\t\t<th class=\"tlrpt2\">Pilot Dia:</th>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\">%-8.4f</td>\n", plt_dia);
}

procedure subrow_turret_dia_len
{
	call(format_turret);
	call(format_tl_dia);
	call(format_tl_len);
}

procedure subrow_turret_crad_inid
{
	call(format_turret);
	call(format_cradius);
	call(format_insrt_id);
}

procedure row_image_num_desc_material
{
	call(open_row);
	call(format_tool_image);
	call(format_tl_num);
	call(format_tl_desc_cs3);
	call(format_tool_material);
	call(close_row);
}
procedure row_image_num_desc_material_3row
{
	call(open_row);
	call(format_tool_image_3row);
	call(format_tl_num);
	call(format_tl_desc_cs3);
	call(format_tool_material);
	call(close_row);
}

procedure row_tnotes
{
	call(open_row);
	call (format_tm_notes);
	call(close_row);
}

procedure row_turret_dia_len_sideang
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_sideang);
	call(close_row);
}

procedure row_turret_dia_len_cradius
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_cradius);
	call(close_row);
}

procedure row_turret_dia_len_tipangl
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_tipangl);
	call(close_row);
}

procedure row_turret_dia_len
{

	call(open_row);
	call(subrow_turret_dia_len);
	//	spacer to fill up space and help align columns
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2></td>\n");
	call(close_row);
}

procedure row_turret_dia_len_pitch
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_pitch);
	call(close_row);
}

procedure row_turret_dia_len_plt
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_plt_dia);
	call(close_row);
}

procedure row_turret_dia_len_body
{
	call(open_row);
	call(subrow_turret_dia_len);
	call(format_body_dia);
	call(close_row);
}

procedure row_turret_crad_inid_insiz
{
	call(open_row);
	call(subrow_turret_crad_inid);
	call(format_insrtsiz);
	call(close_row);
}

procedure row_turret_crad_inid_width
{
	call(open_row);
	call(subrow_turret_crad_inid);
	call(format_width);
	call(close_row);
}

procedure row_turret_crad_inid
{
	call(open_row);
	call(subrow_turret_crad_inid);
	//	space for help align columns
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=2></td>\n");
	call(close_row);
}

//	Fail-safe format: default procedure in event of failure
//	Turning
procedure section_2410000
{
	call(create_tlcell);
	call(row_image_num_desc_material);
	call(open_row);
	call(format_turret);
	call(close_row);
	call(row_tnotes);
	call(close_tlcell);
}

// Turning tool formats

procedure section_2420401	// face turn
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_crad_inid_insiz);
	call(row_tnotes);
	call(close_tlcell);
}


procedure section_2420402	// od turn
{
	call(section_2420401);
}

procedure section_2420403	// id turn
{
	call(section_2420401);
}

// Grooving tool formats

procedure section_2420404	// face groove
{
	call(create_tlcell);
	call(row_image_num_desc_material);
	call(row_turret_crad_inid);
	call(open_row);
	call(format_max_depth);
	call(format_width);
	call(close_row);
	call(row_tnotes);
	call(close_tlcell);
}


procedure section_2420405	// od groove
{
	call(section_2420404);
}

procedure section_2420406	// id groove
{
	call(section_2420404);
}

// Threading tool formats

procedure section_2420407
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_crad_inid_width);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420408	// id thread
{
	call(section_2420407);
}


// Special tool formats

procedure section_2420409	// special 
{
	call(create_tlcell);
	call(open_row);
	call(format_tool_image_3row);
	call(format_tl_num);
	call(format_tl_desc_cs5);
	call(close_row);
	call(open_row);
	//	add a spacers to align rows
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=3></td>\n");
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" width=\"15%%\"></td>\n");
	call(format_length);
	call(format_width);
	call(close_row);
	call(row_tnotes);
	call(close_tlcell);
}


// Rotating Milling tool formats

procedure section_2420101  // End Mill
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len_sideang);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420102  // Ball Mill
{
	call(create_tlcell);
	call(row_image_num_desc_material);
	call(row_turret_dia_len_sideang);
	call(open_row);
	call(format_cradius);
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=6></td>\n");
	call(close_row);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420103  // Face Mill
{
	call(section_2420102);
}

procedure section_2420104  // Form Mill
{
	call(create_tlcell);
	call(row_image_num_desc_material);
	call(row_turret_dia_len_cradius);
	call(open_row);
	call(format_body_dia);
	//	 filler, make columns line up
	format("\t\t\t\t\t\t\t<td class=\"tlrpt2\" colspan=5</td>\n");
	call(close_row);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420105  // Bull Mill
{
	call(section_2420102);
}


// Rotating hole tool formats

procedure section_2420201 // Spot Drill
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len_tipangl);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420202 // Twist Drill
{
	call(section_2420201);
}

procedure section_2420203 // Reamer
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420204 // Bore
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420205 // Tap
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len_pitch);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420206 // Counterbore
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len_plt);
	call(row_tnotes);
	call(close_tlcell);
}

procedure section_2420207 // Countersink
{
	call(section_2420201);
}

procedure section_2420208 // Form Hole
{
	call(section_2420206);
}

procedure section_2420209 // Center Drill
{
	call(create_tlcell);
	call(row_image_num_desc_material_3row);
	call(row_turret_dia_len_body);
	call(row_tnotes);
	call(close_tlcell);
}


// Fixed hole tool formats

procedure section_2420301	// fixed spot
{
	call(section_2420201);
}

procedure section_2420302	// fixed twist
{
	call(section_2420201);
}

procedure section_2420303	// fixed reamer
{
	call(section_2420203);
}

procedure section_2420304	// fixed boring
{
	call(section_2420204);
}

procedure section_2420305	// fixed tap
{
	call(section_2420205);
}

procedure section_2420306	// fixed counterbore
{
	call(section_2420206);
}

procedure section_2420307	// fixed countersink
{
	call(section_2420201);
}

procedure section_2420308	// fixed form hole
{
	call(section_2420206);
}

procedure section_2420309	// fixed center drill
{
	call(section_2420209);
}

